
	.NOLIST

	.INCLUDE "m8535def.inc"


;.include "utility_macros.inc"
;.include "ASCII_table.asm"

	.LIST

#define old_second r20
#define temp2 r23
#define temp r24
#define temp1 r25

; Select fosc
#define fosc 8000000			; 8 MHz
;#define fosc 4000000			; 4 MHz


#define	baud 9600				; Baud rate

;DS1307 registers equates
.equ   	Seconds=0x00
.equ   	Minutes=0x01
.equ   	Hours=0x02
.equ   	Day=0x03
.equ   	Date=0x04
.equ   	Month=0x05
.equ   	Year=0x06
.equ   	DS1307_Control=0x07

;DS1307 internal ram equates
.equ   	ds1307_ram_start=0x08
.equ   	ds1307_ram_end=0x3f

;DS1307 bits definitions
.equ   	clock_halt=7					;In Seconds register
.equ   	AM_PM=5							;In Hours register
.equ   	mode_12h_24h=6					;In Hours register
.equ   	DS1307_RS0=0					;In Control register
.equ   	DS1307_RS1=1					;In Control register
.equ   	DS1307_SQWE=4					;In Control register
.equ   	DS1307_OUT=7					;In Control register

.equ	SCL=pc5							;TWI SCL pin
.equ	SDA=pc4							;TWI SDA pin

#define Seconds_offset TWI_data_bfr
#define Minutes_offset TWI_data_bfr+1
#define Hours_offset TWI_data_bfr+2
#define TWI_data_bfr_size 8

;RAM nedded for this package
.dseg
TWI_data_bfr:		.byte	TWI_data_bfr_size	;Size of TWI buffer if used


.CSEG
	.org	0
	
;Disable Global Interrupt
	cli
;Set up stack pointer
	ldi		temp,high(ramend)
	out		sph,temp
	ldi		temp,low(ramend)
	out		spl,temp

	rcall	UART_INIT

; Send some UART check char
	ldi		temp, '>'
	rcall	COUT
	ldi		temp, 0x0D
	rcall	COUT
	ldi		temp, 0x0A
	rcall	COUT

	rcall	twi_init

	ldi		acc, Seconds			; Start reading from Seconds (address 0x00)
	ldi		count, 8				; Read all 8 registers
	ldi		yl, low (TWI_data_bfr)	; Point Y to TWI_data_bfr
	ldi		yh, high (TWI_data_bfr)
	rcall 	twi_read				; Data read into TWI_data_bfr

	lds		temp, TWI_data_bfr		; Make sure that CH is 0
	andi	temp,~ (1<<clock_halt)	; Start DS1307 if clock halt was set
	sts		TWI_data_bfr, temp

	ldi		acc, Seconds			; Start writing from Seconds (address 0x00)
	ldi		count, 8				; only 1 register to write
	ldi		yl, low (TWI_data_bfr)	; Point Y to TWI_data_bfr
	ldi		yh, high (TWI_data_bfr)
	rcall 	twi_write

	clr		old_second				; Zero old_second

; Clock is now running

check_for_second_tick:

	ldi		acc, Seconds			; Start reading  from Seconds (address 0x00)
	ldi		count, 8				; Read all 8 registers
	ldi		yl, low (TWI_data_bfr)	; Point Y to TWI_data_bfr
	ldi		yh, high (TWI_data_bfr)
	rcall 	twi_read				; read seconds only

	lds		temp, TWI_data_bfr
	cp		temp, old_second
	breq	check_for_second_tick

	mov		old_second, temp

; Print time
	ldi		temp, 0x0D
	rcall	COUT
	lds		temp1, Hours_offset
	rcall	print_clock_register
	ldi		temp, ':'
	rcall	COUT

	lds		temp1, Minutes_offset
	rcall	print_clock_register
	ldi		temp, ':'
	rcall	COUT

	lds		temp1, Seconds_offset
	rcall	print_clock_register

	rjmp	check_for_second_tick


print_clock_register:
	mov		temp, temp1
	swap 	temp
	andi	temp, 0x0f
	subi	temp,-0x30
	rcall	COUT
;swap 	temp1
	mov		temp, temp1
	andi	temp, 0x0f
	subi	temp,-0x30
	rcall	COUT
	ret


;UART_INIT - Initialize the UART
UART_INIT:
	ldi		temp,low(fosc/(16*baud)-1)
	ldi		temp1,high(fosc/(16*baud)-1)	;If used
SETBAUD:
	out		UBRRH,temp1		;baud register high
	out		UBRRL,temp		;baud register low	
	ldi		temp,(1<<RXEN)|(1<<TXEN)		
	out		UCSRB,temp		;enable bits
	ret  

;COUT Output temp to UART.
COUT:
	sbis	UCSRA,UDRE
	rjmp	COUT            ;loop until UDRE=1
	out		UDR,temp         ;send character     
	ret


.include "I2C_TWI.asm"

